> ## Documentation Index
> Fetch the complete documentation index at: https://stytch.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Get TOTP Recovery Codes

> Retrieve the recovery codes for a TOTP instance tied to a User.



## OpenAPI

````yaml POST /v1/totps/recovery_codes
openapi: 3.0.3
info:
  title: Stytch API
  description: The Stytch API provides endpoints for authentication and user management.
  version: 2.1.1
  contact:
    name: Stytch Support
    url: https://stytch.com/docs
    email: support@stytch.com
servers:
  - url: https://api.stytch.com
    description: Production server
  - url: https://test.stytch.com
    description: Test server
security:
  - basicAuth: []
paths:
  /v1/totps/recovery_codes:
    post:
      tags:
        - Totp
      summary: Recoverycodes
      description: Retrieve the recovery codes for a TOTP instance tied to a User.
      operationId: api_totp_v1_RecoveryCodes
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/api_totp_v1_RecoveryCodesRequest'
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/api_totp_v1_RecoveryCodesResponse'
        '400':
          description: Bad request
        '401':
          description: Unauthorized
          content:
            application/json:
              example:
                status_code: 401
                request_id: request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141
                error_type: unauthorized_credentials
                error_message: Unauthorized credentials.
                error_url: https://stytch.com/docs/api/errors/401
        '429':
          description: Too Many Requests
          content:
            application/json:
              example:
                status_code: 429
                request_id: request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141
                error_type: too_many_requests
                error_message: Too many requests have been made.
                error_url: https://stytch.com/docs/api/errors/429
        '500':
          description: Internal server error
          content:
            application/json:
              example:
                status_code: 500
                request_id: request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141
                error_type: internal_server_error
                error_message: >-
                  Oops, something seems to have gone wrong, please reach out to
                  support@stytch.com to let us know what went wrong.
                error_url: https://stytch.com/docs/api/errors/500
      x-code-samples:
        - lang: csharp
          label: C#
          source: |-
            // POST /v1/totps/recovery_codes
            const stytch = require('stytch');

            const client = new stytch.Client({
              project_id: '${projectId}',
              secret: '${secret}',
            });

            const params = {
              user_id: "user-test-16d9ba61-97a1-4ba4-9720-b03761dc50c6",
            };

            client.TOTPs.RecoveryCodes(params)
              .then(resp => { console.log(resp) })
              .catch(err => { console.log(err) });
        - lang: go
          label: Go
          source: "// POST /v1/totps/recovery_codes\npackage main\n\nimport (\n\t\"context\"\n\t\"log\"\n\n\t\"github.com/stytchauth/stytch-go/v18/stytch/consumer/stytchapi\"\n\t\"github.com/stytchauth/stytch-go/v18/stytch/consumer/totps\"\n)\n\nfunc main() {\n\tclient, err := stytchapi.NewClient(\n\t\t\"${projectId}\",\n\t\t\"${secret}\",\n\t)\n\tif err != nil {\n\t\tlog.Fatalf(\"error instantiating client: %v\", err)\n\t}\n\n\tparams := &totps.RecoveryCodesParams{\n\t\tUserID: \"user-test-16d9ba61-97a1-4ba4-9720-b03761dc50c6\",\n\t}\n\n\tresp, err := client.TOTPs.RecoveryCodes(context.Background(), params)\n\tif err != nil {\n\t\tlog.Fatalf(\"error in method call: %v\", err)\n\t}\n\n\tlog.Println(resp)\n}\n"
        - lang: java
          label: Java
          source: |-
            // POST /v1/totps/recovery_codes
            package com.example;

            import com.stytch.java.common.StytchResult;
            import com.stytch.java.consumer.models.totps.RecoveryCodesRequest;
            import com.stytch.java.consumer.StytchClient;

            public class Main {
                public static void main(String[] args) {
                    StytchClient.configure("${projectId}", "${secret}");

                    RecoveryCodesRequest params = new RecoveryCodesRequest();
                    params.setUserId("user-test-16d9ba61-97a1-4ba4-9720-b03761dc50c6");

                    Object result = StytchClient.getTOTPs().recoveryCodes(params);
                    if (result instanceof StytchResult.Success) {
                      System.out.println(((StytchResult.Success) result).getValue());
                    } else {
                      System.out.println(((StytchResult.Error) result).getException());
                    }
                }
            }
        - lang: kotlin
          label: Kotlin
          source: |
            // POST /v1/totps/recovery_codes
            package com.example

            import com.stytch.java.consumer.StytchClient
            import com.stytch.java.consumer.models.totps.RecoveryCodesRequest

            fun main() {
                StytchClient.configure(
                    projectId = "${projectId}",
                    secret = "${secret}",
                )

                when (
                    val result =
                        StytchClient.totps.recoveryCodes(
                            RecoveryCodesRequest(
                                userId = "user-test-16d9ba61-97a1-4ba4-9720-b03761dc50c6",
                            ),
                        )
                ) {
                    is StytchResult.Success -> println(result.value)
                    is StytchResult.Error -> println(result.exception)
                }
            }
        - lang: javascript
          label: Node.js
          source: |-
            // POST /v1/totps/recovery_codes
            const stytch = require('stytch');

            const client = new stytch.Client({
              project_id: '${projectId}',
              secret: '${secret}',
            });

            const params = {
              user_id: "user-test-16d9ba61-97a1-4ba4-9720-b03761dc50c6",
            };

            client.totps.recoveryCodes(params)
              .then(resp => { console.log(resp) })
              .catch(err => { console.log(err) });
        - lang: php
          label: PHP
          source: |-
            $response = $client->totps->recovery_codes([
                'user_id' => 'user-test-16d9ba61-97a1-4ba4-9720-b03761dc50c6',
            ]);
        - lang: python
          label: Python
          source: |
            # POST /v1/totps/recovery_codes
            from stytch import Client

            client = Client(
                project_id="${projectId}",
                secret="${secret}",
            )

            resp = client.totps.recovery_codes(
                user_id="user-test-16d9ba61-97a1-4ba4-9720-b03761dc50c6",
            )

            print(resp)
        - lang: ruby
          label: Ruby
          source: |-
            # frozen_string_literal: true

            # POST /v1/totps/recovery_codes
            require 'stytch'

            client = Stytch::Client.new(
              project_id: "${projectId}",
              secret: "${secret}"
            )

            resp = client.totps.recovery_codes(
              user_id: "user-test-16d9ba61-97a1-4ba4-9720-b03761dc50c6"
              
            )

            puts resp
        - lang: rust
          label: Rust
          source: |-
            // POST /v1/totps/recovery_codes
            use stytch::consumer::client::Client;
            use stytch::consumer::totps::RecoveryCodesRequest;

            fn main() {
                let client = Client::new("${projectId}", "${secret}").unwrap();
                let resp = client.totps.recovery_codes(
                    RecoveryCodesRequest{
                        user_id: "user-test-16d9ba61-97a1-4ba4-9720-b03761dc50c6",
                        ..Default::default()
                    }
                ).await;
                println!("The response is {:?}", resp);
            }
        - lang: bash
          label: cURL
          source: |-
            # POST /v1/totps/recovery_codes
            curl --request POST \
              --url https://test.stytch.com/v1/totps/recovery_codes \
              -u '${projectId}:${secret}' \
              -H 'Content-Type: application/json' \
              -d '{
                "user_id": "user-test-16d9ba61-97a1-4ba4-9720-b03761dc50c6"
              }'
components:
  schemas:
    api_totp_v1_RecoveryCodesRequest:
      type: object
      properties:
        user_id:
          type: string
          description: >-
            The `user_id` of an active user the TOTP registration should be tied
            to. You may use an `external_id` here if one is set for the user.
      description: Request type
      required:
        - user_id
    api_totp_v1_RecoveryCodesResponse:
      type: object
      properties:
        request_id:
          type: string
          description: >-
            Globally unique UUID that is returned with every API call. This
            value is important to log for debugging purposes; we may ask for
            this value to help identify a specific API call when helping you
            debug an issue.
        user_id:
          type: string
          description: The unique ID of the affected User.
        totps:
          type: array
          items:
            $ref: '#/components/schemas/api_totp_v1_TOTP'
          description: >-
            An array containing a list of all TOTP instances (along with their
            recovery codes) for a given User in the Stytch API.
        status_code:
          type: integer
          format: int32
          description: >-
            The HTTP status code of the response. Stytch follows standard HTTP
            response status code patterns, e.g. 2XX values equate to success,
            3XX values are redirects, 4XX are client errors, and 5XX are server
            errors.
      required:
        - request_id
        - user_id
        - totps
        - status_code
    api_totp_v1_TOTP:
      type: object
      properties:
        totp_id:
          type: string
          description: The unique ID for a TOTP instance.
        verified:
          type: boolean
          description: >-
            The verified boolean denotes whether or not this send method, e.g.
            phone number, email address, etc., has been successfully
            authenticated by the User.
        recovery_codes:
          type: array
          items:
            type: string
          description: >-
            The recovery codes used to authenticate the user without an
            authenticator app.
      required:
        - totp_id
        - verified
        - recovery_codes
  securitySchemes:
    basicAuth:
      type: http
      scheme: basic

````